package sys

import (
	"syscall"
)

// SetLimit set NOFILE
func SetLimit(max uint64) error {
	var rlimit syscall.Rlimit

	err := syscall.Getrlimit(syscall.RLIMIT_NOFILE, &rlimit)
	if err != nil {
		return err
	}

	rlimit.Cur = int64(max)
	rlimit.Max = int64(max)
	err = syscall.Setrlimit(syscall.RLIMIT_NOFILE, &rlimit)
	if err != nil {
		return err
	}

	return nil
}
