package wechat

const (
	// TokenExpires token expires time 1 hours
	TokenExpires = 90 * 60
	// TicketExpires ticket expires time 1 hours
	TicketExpires = 60 * 60

	// BaseURL api host
	BaseURL = `https://api.weixin.qq.com`
	// OpenURL open host
	OpenURL = `https://open.weixin.qq.com`

	// PayHost pay base host
	PayHost = `https://api.mch.weixin.qq.com`

	// ErrReqOk request ok
	ErrReqOk = 0

	// PayURLUnifiedOrder pay 付款
	PayURLUnifiedOrder = `/pay/unifiedorder`
	// PayURLPayRefund pay refund 退款
	PayURLPayRefund = `/secapi/pay/refund`
	// PayURLPapPay 委托代扣申请扣款
	PayURLPapPay = `/pay/pappayapply`
	// PayURLPapayEntrust H5 纯签约
	PayURLPapayEntrust = `/papay/h5entrustweb`

	// PayTradeTypeJS JSAPI 公众号支付
	PayTradeTypeJS = `JSAPI`
	// PayTradeTypeNative NATIVE 扫码支付
	PayTradeTypeNative = `NATIVE`
	// PayTradeTypeAPP APP APP支付
	PayTradeTypeAPP = `APP`

	// MsgText text message
	MsgText = `text`
	// MsgImage image message
	MsgImage = `image`
	// MsgVoice voice message
	MsgVoice = `voice`
	// MsgVideo video message
	MsgVideo = `video`
	// MsgShortVideo shortvideo message
	MsgShortVideo = `shortvideo`
	// MsgLocation location message
	MsgLocation = `location`
	// MsgLink link message
	MsgLink = `link`

	// MsgNews news
	MsgNews = `news`
	// MsgMusic music
	MsgMusic = `music`

	// MsgEvent event
	MsgEvent = `event`

	// subscribe
	// subscribe 事件 EventKey 不为空的, 为扫描带参数二维码事件关注
	//

	// MsgEventSubscribe subscribe 订阅
	MsgEventSubscribe = `subscribe`
	// MsgEventUnSubscribe unsubscribe 取消订阅
	MsgEventUnSubscribe = `unsubscribe`

	// MsgEventSCAN 已关注用户扫码事件
	MsgEventSCAN = `SCAN`

	// MsgEventLOCATION 上报地理位置事件
	MsgEventLOCATION = `LOCATION`
	// MsgEventCLICK 自定义菜单点击事件
	MsgEventCLICK = `CLICK`

	// MsgEventVIEW 点击自定义菜单跳转链接时的事件
	MsgEventVIEW = `VIEW`

	// MsgEventTEMPLATESENDJOBFINISH 模版消息发送任务结果事件
	MsgEventTEMPLATESENDJOBFINISH = `TEMPLATESENDJOBFINISH`
)

// text/image/voice/video/shortvideo/location/link
