package wechat

/* ******************************************
	HTTP Status code

	200 ok
	204 处理成功，无返回 Body
	400 协议或者参数非法, PARAM_ERROR
	401 签名验证失败, SIGN_ERROR
	403 权限异常, NO_AUTH
	404 请求的资源不存在, ORDER_NOT_EXIST
	429 请求超过频率限制, RATELIMIT_EXCEEDED
	500 系统错误, SYSTEM_ERROR
	502 服务下线，暂时不可用, SERVICE_UNAVAILABLE
	503 服务不可用，过载保护, SERVICE_UNAVAILABLE
// ****************************************** */

// WepayResponseDetail detail
type WepayResponseDetail struct {
	Field    string `json:"field"`
	Value    string `json:"value"`
	Issue    string `json:"issue"`
	Location string `json:"location"`
}

// WepayResponseMessageV3 v3 返回消息头
type WepayResponseMessageV3 struct {
	Code    string              `json:"code"`
	Message string              `json:"message"`
	Detail  WepayResponseDetail `json:"detail"`
}
